# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys, json
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
import haitum


def resp(ret, recur=False):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        xbmcplugin.setContent(handle, 'videos')
        # xbmcplugin.setPluginFanart()
        # xbmcplugin.setProperty('ViewType', 'InfoWall')
        # xbmcplugin.setSetting(xbmc.)
        # xbmc.executebuiltin('Container.SetViewMode(InfoWall)')
        for elem in ret:
            resp(elem, True)
        return xbmcplugin.endOfDirectory(handle)
    assert isinstance(ret, dict)
    if 'title' not in ret:
        for k, v in ret.items():
            if isinstance(v, list):
                ret = {'title': k, 'json': json.dumps(v)}
            else:
                ret = {'title': k, 'url': v}
    li = xbmcgui.ListItem(ret['title'])
    if 'img' in ret:
        li.setArt({'thumb': ret['img']})
    if 'plot' in ret:
        li.setInfo('video', {'plot': ret['plot']})
    t = True
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            else:
                return xbmc.Player().play(ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8'):
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            else:
                return xbmc.Player().play(ret['url'], li)
        if t:
            t = sub1(ret['url'])
    for k, v in ret.items():
        try:
            ret[k] = v.encode('utf-8')
        except:
            pass
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    l = len(p)
    if o.netloc in ('www.haitum.com', 'www.haitum.net', 'www.haitum.cn', 'www.haituw.com', 'www.haituk.com', 'www.haitudy.com', 'www.haituyy.com'):
        if l < 3:
            return resp({'code': 'haitum 021'})
        if p[1] == 'movie':
            if 'index' in q:
                index = int(q['index'][0])
            else:
                index = -1
            return resp(haitum.movie(url, index))
    if l > 1 and p[1] == 'share':
        return resp({'code': 'haitum 022', 'error': '还没做 而且不打算做 换别的线路看吧'})
    return resp({'code': 'haitum 020', 'error': url})


def sub3(content):
    try:
        data = json.loads(content)
    except Exception as e:
        return resp({'code': 'haitum 030', 'error': str(e)})
    resp(data)


def category(cat):
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    resp(haitum.category(cat, page))


def search(s):
    if not s:
        kb = xbmc.Keyboard(heading='Search')
        kb.doModal()
        if not kb.isConfirmed():
            return
        s = kb.getText()
    if 'page' in q:
        page = int(q['page'][0])
    else:
        page = 1
    resp(haitum.search(s, page))


def get_node(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return resp({'code': 'haitum 010', 'error': str(e)})
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    resp({'title': '电影', 'category': 'dianying'})
    resp({'title': '电视剧', 'category': 'dianshiju'})
    resp({'title': '综艺', 'category': 'zongyi'})
    resp({'title': '动漫', 'category': 'dongman'})
    resp({'title': '纪录片', 'category': 'jilupian'})
    resp({'title': '微电影', 'category': 'weidianying'})
    resp({'title': '豆瓣优片', 'category': 'dbm-dianying'})
    resp({'title': 'Search', 'search': ''})
    get_node('http://ims.tian-le.com/haitum.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
    elif 'category' in q:
        category(q['category'][0])
    elif 'search' in q:
        search(q['search'][0])
